
package mod_ipchat;

import java.io.IOException;
import java.net.Socket;
import mod_ipchat.ChatInThread;
import mod_ipchat.ChatOutThread;

public class ChatClient {
    private Socket outsocket;
    private Socket insocket;
    private boolean running = true;
    Thread chatout;

    public ChatClient(String ip) {
        try {
            this.insocket = new Socket(ip, 8080);
            System.out.println("C: insocket connected");
            this.outsocket = new Socket(ip, 8081);
            System.out.println("C: outsocket connected");
        }
        catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void create() {
        ChatOutThread cot = new ChatOutThread(this.outsocket);
        Thread chatout = new Thread(cot);
        chatout.start();
        ChatInThread cin = new ChatInThread(this.insocket);
        Thread chatin = new Thread(cin);
        chatin.start();
        while (chatin.isAlive() && chatout.isAlive()) {
        }
        if (!chatin.isAlive()) {
            cot.setKill(true);
        } else if (chatout.isAlive()) {
            cin.setKill(true);
        }
        this.running = false;
    }

    public boolean isRunning() {
        return this.running;
    }

    public void setRunning(boolean running) {
        this.running = running;
    }

    public Thread getChatout() {
        return this.chatout;
    }

    public void setChatout(Thread chatout) {
        this.chatout = chatout;
    }
}

   


